var gl;
var yRot = 0;
var zRot = 0;

function initGL(canvas) {
	try {
		// 'experimental-webgl' est utilise depuis la phase de developpement de
		// la specification de webGL il devrait etre remplace par 'webgl' un jour
		gl = canvas.getContext("experimental-webgl");
		gl.viewportWidth = canvas.width;
		gl.viewportHeight = canvas.height;
	} catch (e) {
	}
	if (!gl) {
		alert("Could not initialise WebGL, sorry :-(");
	}
}


/*----------------------------------------------------------------------
 * Creation des membres du robot 
 *---------------------------------------------------------------------*/

function creerJambe()
{
	creerBoite(0.5, 0.5, 2.0);
}

function creerCorps()
{
	creerBoite(1.5, 0.5, 2.0);
}

function creerTete()
{
	creerBoite(1.0, 0.5, 1.0);
}

function creerAvantBras()
{
	creerBoite(0.5, 0.5, 1.5);
}

function creerBras()
{
	creerBoite(0.5, 0.5, 1.5);
}

/*----------------------------------------------------------------------
 * Affichage de la scene 
 *---------------------------------------------------------------------*/
function drawScene() {
	gl.viewport(0, 0, gl.viewportWidth, gl.viewportHeight);
	gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

	/* on choisit l'angle de vue et les dimensions de la scene */
	mat4.perspective(45, gl.viewportWidth / gl.viewportHeight, 0.1, 100.0, pMatrix);

	/* on initialise la matrice */
	mat4.identity(mvMatrix);

	/* on choisit le point de vue */
	mat4.translate(mvMatrix, [0.0, 0.0, -10.0]);

	/* applique une rotation sur l'axe des X pour que l'on ait l'axe des X a
	 * qui part a l'horizontal sur la droite et l'axe Z qui part en vertical en
	 * hauteur */
	mat4.rotate(mvMatrix, degToRad(270), [1, 0, 0]);

	/* applique les rotations issues de l'action de la souris (lorsque cette
	 * partie est activée). */
 	mat4.rotate(mvMatrix, degToRad(yRot), [0, 1, 0]);
  mat4.rotate(mvMatrix, degToRad(zRot), [0, 0, 1]);

	/* decommenter pour afficher le repere */
	// afficherRepere() 

	
}

function webGLStart() {
	var canvas = document.getElementById("robot-canvas");
	initGL(canvas); // Initialise le context GL
	initShaders();
	initBuffers();

	gl.clearColor(0.0, 0.0, 0.0, 1.0); // Specifie les valeurs de couleurs (noire, opacite : 100) lorsque le buffer de couleur est efface.
	gl.clearDepth(1.0);									// Specifie la valeur a utilisr lorsque le buffer de profondeur est efface.
	gl.enable(gl.DEPTH_TEST);						// Active le test de profondeur.
	gl.depthFunc(gl.LEQUAL);						// Les objets proches assombrissent les objets lointains.
  gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT);  // Efface les buffers de couleur et de profondeur

	/* Pour l'interaction avec la souris. Recupere les evenements d'actions sur la
	 * souris et appelle les fonctions correspondantes. */
	/* 
	canvas.addEventListener('mousedown', mouseDown, true);
	canvas.addEventListener('mousemove', mouseMove, true);
	canvas.addEventListener('mouseup', mouseUp, true);
	*/
	/* Pour les interactions avec le clavier.
	 * document.keyDown = ...
	 */
	drawScene();
}


/*----------------------------------------------------------------------
 * Gestion des evenements de la souris
 *---------------------------------------------------------------------*/
var lastX;
var lastY;
var dragging = false;

function mouseDown(event) {
	lastX = event.clientX;
	lastY = event.clientY;
	dragging = true;
}

function mouseUp() {
	dragging = false;
}

/* Lorsque la souris est tenue cliquee, on rend de nouveau la scene en
 * incrementant progressivement les angles au fur et a mesure. */
function mouseMove(event) {
	if (dragging) {
		zRot += (event.clientX - lastX) / 5.0;
		yRot += (event.clientY - lastY) / 5.0;

		lastX = event.clientX;
		lastY = event.clientY;
		drawScene();
	}
}

